
<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :isValidate="true" :offsetArrow="20" :spanTitle="3" title="Ir al Reporte" v-on:clickEvent="goToReport" style="margin-bottom:2.5rem"/>
    </header>


    <div class="flex justify-between" style="margin:3rem 6rem !important; color: white; background-color: #818181 !important; padding: 10px 30px" >
      <h3 class="bolt-light"> {{ material.originalTitle.toUpperCase() }}  </h3> 
       <!-- <span> REVISADO POR:   {{this.userLogin.toUpperCase()}} </span> -->
    </div>

     <el-row style="margin: 5rem 10rem;" v-if="material.reviewObj.userLogin">
        <el-col :span="6">
          <h3 class="bolt-light" >REVISADO POR: </h3>     
        </el-col>
        <el-col :span="15">
            <el-row :span="24" v-for="(item, index) in userReview" :key="index" style="margin-top: 1rem">
            <el-col :span="12" class="text-bold" >{{ item.user }}
            </el-col>
            <el-col :span="12"> ({{ item.date }})
            </el-col>
          </el-row>          
        </el-col>
      </el-row> 

    <section style="margin:0rem 6rem">
      <!-- CUADRADITOS DE INFORMACION DEL ESTADO DE LOS PEDIDOS -->
      <div style="margin:3rem 6rem">
        <DescriptionStateOrders :colBoxes="8" TextSquareGray="Sin Revisar" TextSquareRed="Pendiente de Reposición" TextSquareGreen="Aprobado" :TextSquareBlue="''" :TextSquareOrange="''"> </DescriptionStateOrders>
      </div>

      <!-- SELECT QUE FILTRA LA TEMPORADA  -->
      <div style="margin:3rem">
        <el-row :gutter="20">
          <el-col :span="6" :offset="17">
            <el-select @change="changeSeason(temporada)" v-model="temporada"  placeholder="Temporada">
              <el-option
              v-for="item in selectItems" 
              :key="item.value"
              :label="item.label"
              :value="item.value">
              </el-option>
            </el-select>  
          </el-col>  
        </el-row>
      </div>
      <!-- TITULO DE LA TEMPORADA  -->
      <div style="background-color: #fedbcc !important; color: #252525 !important; padding: 8px 20px; margin:3rem 6rem">
        <h3 class="text-bold"> <span class="bolt" style="margin-left: 10px" > {{ seasonFilterByTemp.seasonString }} </span> <span class="bolt-light"> ({{ Object(seasonFilterByTemp).chapters}} Capítulos) </span> </h3> 
      </div>
      <!-- FILTRO Y BUSCADOR  -->
      <section style="margin:4rem 6rem">
        <el-row :gutter="20">
        <!-- Filtros --> 
          <el-col :span="18" class="text-end">
            <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
          </el-col>
          <el-col :span="6">
            <app-search-filter v-model="textSearch"></app-search-filter>
          </el-col>  
        </el-row>
      </section>
      <section style="margin:3rem 6rem">
        <el-row :gutter="100">
            <el-col style="margin-bottom:3rem" :name="index" v-for="(value, index) in chapters" :key="index" :span="8">
              <el-card style="height: 200px" class=" pointer cardCap box-shadow-right" shadow="always" :class="'addClass-'+season+'-'+value.chapter">
                <div @click="goToChapter(season, value, value.chapter)">
                  <div class="title-views text-dark-gray-1" style="margin-bottom:0.5rem" :class="value.colorCap">CAPÍTULO</div>
                  <div class="title-chapters text-dark-gray-1" :class="value.colorCap">{{value.chapter}}</div>
                  <div>
                    <h4 v-if="conditionalEtiquetas(value)" class="text-dark-gray-1" style="margin-top: 0.5rem">Etiquetas:</h4>
                    <p style="margin-top: 0.5rem">
                      <span class="text-dark-gray-1"  v-for="(tag, index) in value.tags" :key="index"> {{ tag }}  </span>
                    </p> 
                  </div>
                </div>
            </el-card>
          </el-col>
        </el-row>
      </section>
    </section>
  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import DescriptionStateOrders from '@/components/DescriptionStateOrders.vue' 
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import { modifyText } from '../../../utils/modifyText.js'
export default {
  components: {
    ReturnButton,
    DescriptionStateOrders,
   'app-search-filter': SearchFilter,
   'app-select': Select,
  },
  data() {
    return {
      material: JSON.parse(this.$localStorage.get("selectedMaterial")),
      userLogin: localStorage.getItem('userName'),
      season: [],
      seasonFilterByTemp: [],
      selectItems: [],
      allFilters: [
        {value: 'state', label: 'Estado del capítulo'},
        {value: 'chapter', label: 'Número del capítulo'},
        {value: 'tags', label: 'Etiquetas'},
      ],
      textSearch: '',
      filterSelect: '',
      temporada: '',
      isContractsProvider: false,
      userReview: [],
    }
  },
  created() {
    this.season = this.material.numChapters
    this.seasonFilterByTemp = this.material.numChapters[0]
    this.selectFilterSeason()
    this.isContractsProvider = this.$route.params.isContractsProvider
    this.userReview = JSON.parse(this.$localStorage.get("selectedMaterial")).reviewObj.userLogin

  },
  methods: {
    conditionalEtiquetas(value) {
      return value.tags &&  value.tags.length > 0 ? value.tags.length !== 0 ?  true : false : false
    },
    verifyTags (arrayTags, textSearch) {
      let bolean = false 
      arrayTags.map((el, i, arr) => {
         if ( modifyText(el).search(modifyText(textSearch)) != -1) {
           bolean = true
         }
      })
      return bolean
    },
    goToReport() {
      if ( this.isContractsProvider === true ) {
        this.$router.push({name: 'revNovelDoc', params: { isContractsProvider: true }})  
      }
      else {
        this.$router.push({name: 'revNovelDoc'})
      }      
    },
    changeSeason(temp) {
      this.seasonFilterByTemp = []
      this.seasonFilterByTemp = this.season[temp]
      this.indexTemp = temp
    },
    selectFilterSeason() {
      this.season.map((el, i, arr) => {
        let objt = {
          value: i,
          label: 'Temporada ' + (i+1)
        }
        el.seasonString = 'Temporada ' + (i+1)
        this.selectItems.push(objt)
      }) 
    },
    goToChapter( season, value, cap) {
      let tempo = Number(this.seasonFilterByTemp.season)   
      if (this.isContractsProvider === true ){
        this.$router.push({name: 'formByCap', params: { chapter: value, temporada: tempo, capitulo: cap, isContractsProvider: true }})
      }
      else {
        this.$router.push({name: 'formByCap', params: { chapter: value, temporada: tempo, capitulo: cap }})
      }     
      
    }
  },
  computed: {
    chapters () {
      let allCap = this.seasonFilterByTemp.infoByChapter.filter(
        m => m.colorCap  !== undefined
      ) 
      let capSelected = allCap
      
      if (this.filterSelect == 'chapter' && this.textSearch) {
        capSelected = allCap.filter(
          m => String(m.chapter).indexOf(modifyText(this.textSearch)) > -1)
      }
      else if (this.filterSelect == 'tags' && this.textSearch) {
        capSelected = allCap.filter(
          m => this.verifyTags(m.tags, this.textSearch))
      }    
      else if (this.filterSelect && this.textSearch) {
        capSelected = allCap.filter(
          m => m[this.filterSelect].indexOf(this.textSearch) !== -1)
      }
      return capSelected
    }
  }
}
</script>